linphone Namespace Reference

Namespace that holds all liblinphone's API classes and enumerations. More...

## Classes

class | Account
| Object that represents a Linphone Account. More...
class | AccountCreator
| The object used to configure an account on a server via XML-RPC, see https://wiki.linphone.org/xwiki/wiki/public/view/Lib/Features/Override%20account%20creator%20request/. More...
class | AccountCreatorListener
| An object to handle the responses callbacks for handling the AccountCreator operations. More...
class | AccountListener
| An object to handle the callbacks for the handling of Account objects. More...
class | AccountParams
| Object that is used to set the different parameters of a Account. More...
class | Address
| Object that represents a parsed SIP address. More...
class | Alert
| Object that represents an alert. More...
class | AlertListener
| Object that represents a callback attached to an alert. More...
class | AudioDevice
| Object holding audio device information. More...
class | AuthInfo
| Object holding authentication information. More...
class | Buffer
| The object representing a data buffer. More...
class | Call
| This object represents a call issued or received by the Core. More...
class | CallListener
| That class holds all the callbacks which are called by Call objects. More...
class | CallLog
| Object used to keep track of all calls initiated, received or missed. More...
class | CallParams
| An object containing various parameters of a Call. More...
class | CallStats
| This object carry various statistic informations regarding the quality of an audio or video stream for a given Call. More...
class | ChatMessage
| An chat message is the object that is sent or received through a ChatRoom. More...
class | ChatMessageListener
| An object to handle the callbacks for the handling a ChatMessage objects. More...
class | ChatMessageReaction
| A chat message reaction is an emoji sent by someone in the same chat room to react to a specific ChatMessage. More...
class | ChatRoom
| A chat room is the place where ChatMessage are exchanged. More...
class | ChatRoomListener
| An object to handle the callbacks for the handling a ChatRoom objects. More...
class | ChatRoomParams
| Object defining parameters for a ChatRoom. More...
class | Conference
| A conference is the object that allow to make calls when there are 2 or more participants. More...
class | ConferenceInfo
| Object defining all information related to a conference. More...
class | ConferenceListener
| An object to handle the callbacks for the handling a Conference objects. More...
class | ConferenceParams
| Object defining parameters for a Conference. More...
class | ConferenceScheduler
| Object used to create remote conferences and send ICS to notify participants. More...
class | ConferenceSchedulerListener
| An object to handle the callbacks of ConferenceScheduler object. More...
class | Config
| This object is used to manipulate a configuration file. More...
class | Content
| This object holds data that can be embedded in a signaling message. More...
class | Core
| Main object to instanciate and on which to keep a reference. More...
class | CoreListener
| That class holds all the callbacks which are called by Core. More...
class | DialPlan
| Represents a dial plan. More...
class | Dictionary
| Object that represents key-value pair container. More...
class | DigestAuthenticationPolicy
| The DigestAuthenticationPolicy holds parameters relative to digest authentication procedures. More...
class | ErrorInfo
| Object representing full details about a signaling error or status. More...
class | Event
| Object representing an event state, which is subcribed or published. More...
class | EventListener
| An object to handle the callbacks for handling the Event operations. More...
class | EventLog
| Object that represents an event that must be stored in database. More...
class | Factory
| The factory is a singleton object devoted to the creation of all the objects of Liblinphone that cannot be created by Core itself. More...
class | Friend
| This object is used to store a SIP address. More...
class | FriendList
| This object representing a list of Friend. More...
class | FriendListListener
| An object to handle the callbacks for Friend synchronization. More...
class | FriendListener
| An object to handle the callbacks for Friend. More...
class | FriendPhoneNumber
| Object that represents a Friend's phone number. More...
class | Headers
| Object representing a chain of protocol headers. More...
class | ImNotifPolicy
| Policy to use to send/receive instant messaging composing/delivery/display notifications. More...
class | InfoMessage
| Object representing an informational message sent or received by the core. More...
class | Ldap
| Object that represents a Linphone Ldap. More...
class | LdapParams
| Object that is used to set the different parameters of a Ldap. More...
class | LoggingService
| Singleton class giving access to logging features. More...
class | LoggingServiceListener
| Listener for LoggingService. More...
class | MagicSearch
| A MagicSearch is used to do specifics searchs. More...
class | MagicSearchListener
| A MagicSearchListener is used to do specifics searchs. More...
class | NatPolicy
| Policy to use to pass through NATs/firewalls. More...
class | Participant
| Identifies a member of a Conference or ChatRoom. More...
class | ParticipantDevice
| This object represents a unique device for a member of a Conference or ChatRoom. More...
class | ParticipantDeviceIdentity
| This object is only used on server side for ChatRoom with ChatRoom::Backend::FlexisipChat backend. More...
class | ParticipantDeviceListener
| An object to handle the callbacks for the handling a ParticipantDevice objects. More...
class | ParticipantImdnState
| This object represents the delivery/display state of a given chat message for a given participant. More...
class | ParticipantInfo
| Object defining all information related to a participant. More...
class | PayloadType
| Object representing an RTP payload type. More...
class | Player
| Player interface. More...
class | PlayerListener
| An object to handle the callbacks for the handling a Player objects. More...
class | PresenceActivity
| Presence activity type holding information about a presence activity. More...
class | PresenceModel
| Presence model type holding information about the presence of a person. More...
class | PresenceNote
| Presence note type holding information about a presence note. More...
class | PresencePerson
| Presence person holding information about a presence person. More...
class | PresenceService
| Presence service type holding information about a presence service. More...
class | ProxyConfig
| Represents an account configuration to be used by Core. More...
class | PushNotificationConfig
| Object holding push notification config that will be set in the contact URI parameters of the Contact header in the REGISTER, if the AccountParams is configured to allow push notifications, see AccountParams::setPushNotificationAllowed(). More...
class | PushNotificationMessage
| Object holding chat message data received by a push notification on iOS platform only. More...
class | Range
| Structure describing a range of integers. More...
class | Recorder
| Object used to record the audio or video of a call. More...
class | RecorderParams
| Object containing various parameters of a Recorder. More...
class | SearchResult
| The SearchResult object represents a result of a search. More...
class | SignalInformation
| Object to get signal (wifi/4G etc...) informations. More...
class | Transports
| SIP transports & ports configuration object. More...
class | Tunnel
| Linphone tunnel object. More...
class | TunnelConfig
| Tunnel settings. More...
class | Vcard
| Object storing contact information using vCard 4.0 format. More...
class | VideoActivationPolicy
| Object describing policy regarding video streams establishments. More...
class | VideoDefinition
| This object represents a video definition, eg. More...
class | VideoSourceDescriptor
| Object that is used to describe a video source. More...
class | XmlRpcRequest
| The XmlRpcRequest object representing a XML-RPC request to be sent. More...
class | XmlRpcRequestListener
| An object to handle the callbacks for handling the XmlRpcRequest operations. More...
class | XmlRpcSession
| The XmlRpcSession object used to send XML-RPC requests and handle their responses. More...

## Typedefs

typedef int | Status

## Enumerations

enum class | AVPFMode { Default = -1 , Disabled = 0 , Enabled = 1 }
| Enum describing RTP AVPF activation modes. More...
enum class | AuthMethod { HttpDigest = 0 , Tls = 1 }
| Enum describing the authentication methods. More...
enum class | CodecPriorityPolicy { Basic = 0 , Auto = 1 }
| Codec priority policies. More...
enum class | ConfiguringState { Successful = 0 , Failed = 1 , Skipped = 2 }
| Describes the state of the remote configuring process of the Core object, 'Skipped' when the feature is disabled.
enum class | ConsolidatedPresence { Online = 0 , Busy = 1 , DoNotDisturb = 2 , Offline = 3 }
| Consolidated presence information: 'online' means the user is open for communication, 'busy' means the user is open for communication but involved in an other activity, 'do not disturb' means the user is not open for communication, and 'offline' means that no presence information is available.
enum class | EcCalibratorStatus { InProgress = 0 , Done = 1 , Failed = 2 , DoneNoEcho = 3 }
| Enum describing the result of the echo canceller calibration process. More...
enum class | GlobalState { Off = 0 , Startup = 1 , On = 2 , Shutdown = 3 , Configuring = 4 , Ready = 5 }
| Describes the global state of the Core object. More...
enum class | IceState { NotActivated = 0 , Failed = 1 , InProgress = 2 , HostConnection = 3 , ReflexiveConnection = 4 , RelayConnection = 5 }
| Enum describing ICE states. More...
enum class | LimeState { Disabled = 0 , Mandatory = 1 , Preferred = 2 }
enum class | LogCollectionState { Disabled = 0 , Enabled = 1 , EnabledWithoutPreviousLogHandler = 2 }
| Whether or not to keep a file with the logs.
enum class | LogLevel { Debug = 1<<0 , Trace = 1<<1 , Message = 1<<2 , Warning = 1<<3 , Error = 1<<4 , Fatal = 1<<5 }
| Verbosity levels of log messages. More...
enum class | MediaDirection { Invalid = -1 , Inactive = 0 , SendOnly = 1 , RecvOnly = 2 , SendRecv = 3 }
| Indicates for a given media the stream direction. More...
enum class | MediaEncryption { None = 0 , SRTP = 1 , ZRTP = 2 , DTLS = 3 }
| Enum describing type of media encryption types. More...
enum class | MediaResourceMode { ExclusiveMediaResources = 0 , SharedMediaResources = 1 }
| Media resource usage. More...
enum class | PresenceBasicStatus { Open = 0 , Closed = 1 }
| Basic status as defined in section 4.1.4 of RFC 3863. More...
enum class | Privacy { None = 0 , User = 1 , Header = 2 , Session = 4 , Id = 8 , Critical = 16 , Default = 32768 }
| Defines privacy policy to apply as described by rfc3323. More...
enum class | PublishState { None = 0 , IncomingReceived = 1 , Ok = 2 , Error = 3 , Expiring = 4 , Cleared = 5 , Terminating = 6 , OutgoingProgress = 7 }
| Enum for publish states. More...

enum class

Reason {
None = 0 ,
NoResponse = 1 ,
Forbidden = 2 ,
Declined = 3 ,
NotFound = 4 ,
NotAnswered = 5 ,
Busy = 6 ,
UnsupportedContent = 7 ,
BadEvent = 8 ,
IOError = 9 ,
DoNotDisturb = 10 ,
Unauthorized = 11 ,
NotAcceptable = 12 ,
NoMatch = 13 ,
MovedPermanently = 14 ,
Gone = 15 ,
TemporarilyUnavailable = 16 ,
AddressIncomplete = 17 ,
NotImplemented = 18 ,
BadGateway = 19 ,
SessionIntervalTooSmall = 20 ,
ServerTimeout = 21 ,
Unknown = 22 ,
Transferred = 23 ,
ConditionalRequestFailed = 24
}

| Enum describing various failure reasons or contextual information for some events. More...
enum class | RegistrationState { None = 0 , Progress = 1 , Ok = 2 , Cleared = 3 , Failed = 4 , Refreshing = 5 }
| Describes proxy registration states. More...
enum class | SessionExpiresRefresher { Unspecified = 0 , UAS = 1 , UAC = 2 }
| Session Timers refresher.
enum class | SignalStrengthUnit { Rssi = 0 , Dbm = 1 }
| All signal units that a device can use.
enum class | SignalType { Wifi = 0 , Mobile = 1 , Other = 2 }
| All signal types that a device can use.
enum class | SrtpSuite { AESCM128HMACSHA180 = 0 , AESCM128HMACSHA132 = 1 , AES192CMHMACSHA180 = 2 , AES192CMHMACSHA132 = 3 , AES256CMHMACSHA180 = 4 , AES256CMHMACSHA132 = 5 , AEADAES128GCM = 6 , AEADAES256GCM = 7 , Invalid = 255 }
| Enum describing type of SRTP encryption suite.
enum class | StreamType { Audio = 0 , Video = 1 , Text = 2 , Unknown = 3 }
| Enum describing the stream types.
enum class | SubscribePolicy { SPWait = 0 , SPDeny = 1 , SPAccept = 2 }
| Enum controlling behavior for incoming subscription request. More...
enum class | SubscriptionDir { Incoming = 0 , Outgoing = 1 , InvalidDir = 2 }
| Enum for subscription direction (incoming or outgoing). More...
enum class | SubscriptionState { None = 0 , OutgoingProgress = 1 , IncomingReceived = 2 , Pending = 3 , Active = 4 , Terminated = 5 , Error = 6 , Expiring = 7 }
| Enum for subscription states. More...
enum class | SupportLevel { NoSupport = 0 , Optional = 1 , Mandatory = 2 }
enum class | ToneID { Undefined = 0 , Busy = 1 , CallWaiting = 2 , CallOnHold = 3 , CallLost = 4 , CallEnd = 5 , CallNotAnswered = 6 }
| Enum listing frequent telephony tones. More...
enum class | TransportType { Udp = 0 , Tcp = 1 , Tls = 2 , Dtls = 3 }
| Enum describing transport type for Address.
enum class | UpnpState { Idle = 0 , Pending = 1 , Adding = 2 , Removing = 3 , NotAvailable = 4 , Ok = 5 , Ko = 6 , Blacklisted = 7 }
| Enum describing uPnP states. More...
enum class | VersionUpdateCheckResult { UpToDate = 0 , NewVersionAvailable = 1 , Error = 2 }
| Enum describing the result of a version update check.
enum class | VideoSourceType { Unknown , Call , Camera , Image }
| Enum representing the type of a video source. More...
enum class | XmlRpcArgType { None = 0 , Int = 1 , String = 2 , StringStruct = 3 }
| Enum describing the types of argument for XmlRpcRequest.
enum class | XmlRpcStatus { Pending = 0 , Ok = 1 , Failed = 2 }
| Enum describing the status of a XmlRpcRequest.
enum class | ZrtpKeyAgreement { Invalid = 0 , Dh2K = 1 , Dh3K = 2 , Ec25 = 3 , Ec38 = 4 , Ec52 = 5 , X255 = 6 , X448 = 7 , K255 = 8 , K448 = 9 , Kyb1 = 10 , Kyb2 = 11 , Kyb3 = 12 , Hqc1 = 13 , Hqc2 = 14 , Hqc3 = 15 , K255Kyb512 = 16 , K255Hqc128 = 17 , K448Kyb1024 = 18 , K448Hqc256 = 19 , K255Kyb512Hqc128 = 20 , K448Kyb1024Hqc256 = 21 }
| Enum describing the ZRTP key exchange algorithns.
enum class | ZrtpPeerStatus { Unknown = 0 , Invalid = 1 , Valid = 2 }
| Enum describing the ZRTP SAS validation status of a peer URI. More...

## Detailed Description

Namespace that holds all liblinphone's API classes and enumerations.

## Enumeration Type Documentation

## AuthMethod

enum class linphone::AuthMethod

strong

Enum describing the authentication methods.

Enumerator
HttpDigest | Digest authentication requested.
Tls | Client certificate requested.

## AVPFMode

enum class linphone::AVPFMode

strong

Enum describing RTP AVPF activation modes.

Enumerator
Default | Use default value defined at upper level.
Disabled | AVPF is disabled.
Enabled | AVPF is enabled.

## CodecPriorityPolicy

enum class linphone::CodecPriorityPolicy

strong

Codec priority policies.

Enumerator
Basic | In this mode, codecs have initial default ordering, that can be changed by the application The answerer of a call accepts codecs with the order given in the offer.
Auto | In this mode, the codec list is managed by the Core according to hardware capabilities in the goal of optimizing video quality and user experience.

## EcCalibratorStatus

enum class linphone::EcCalibratorStatus

strong

Enum describing the result of the echo canceller calibration process.

Enumerator
InProgress | The echo canceller calibration process is on going.
Done | The echo canceller calibration has been performed and produced an echo delay measure.
Failed | The echo canceller calibration process has failed.
DoneNoEcho | The echo canceller calibration has been performed and no echo has been detected.

## GlobalState

enum class linphone::GlobalState

strong

Describes the global state of the Core object.

Enumerator
Off | State in which we're in after Core::stop().
Startup | Transient state for when we call Core::start().
On | Indicates Core has been started and is up and running.
Shutdown | Transient state for when we call Core::stop().
Configuring | Transient state between Startup and On if there is a remote provisionning URI configured.
Ready | Core state after being created by linphone_factory_create_core, generally followed by a call to Core::start()

## IceState

enum class linphone::IceState

strong

Enum describing ICE states.

Enumerator
NotActivated | ICE has not been activated for this call or stream.
Failed | ICE processing has failed.
InProgress | ICE process is in progress.
HostConnection | ICE has established a direct connection to the remote host.
ReflexiveConnection | ICE has established a connection to the remote host through one or several NATs.
RelayConnection | ICE has established a connection through a relay.

## LimeState

enum class linphone::LimeState

strong

Enumerator
Disabled | Lime is not used at all.
Mandatory | Lime is always used.
Preferred | Lime is used only if we already shared a secret with remote.

## LogLevel

enum class linphone::LogLevel

strong

Verbosity levels of log messages.

Enumerator
Debug | Level for debug messages.
Trace | Level for traces.
Message | Level for information messages.
Warning | Level for warning messages.
Error | Level for error messages.
Fatal | Level for fatal error messages.

## MediaDirection

enum class linphone::MediaDirection

strong

Indicates for a given media the stream direction.

Enumerator
Invalid | Default value, shouldn't be used.
Inactive | No active media not supported yet.
SendOnly | Media is only being sent, it won't be received.
RecvOnly | Media will only be received, nothing will be sent.
SendRecv | Media will be sent and received.

## MediaEncryption

enum class linphone::MediaEncryption

strong

Enum describing type of media encryption types.

Enumerator
None | No media encryption is used.
SRTP | Use SRTP media encryption.
ZRTP | Use ZRTP media encryption.
DTLS | Use DTLS media encryption.

## MediaResourceMode

enum class linphone::MediaResourceMode

strong

Media resource usage.

Enumerator
ExclusiveMediaResources | Media resources are not shared.
SharedMediaResources | Media resources are shared.

## PresenceBasicStatus

enum class linphone::PresenceBasicStatus

strong

Basic status as defined in section 4.1.4 of RFC 3863.

Enumerator
Open | This value means that the associated contact element, if any, is ready to accept communication.
Closed | This value means that the associated contact element, if any, is unable to accept communication.

## Privacy

enum class linphone::Privacy

strong

Defines privacy policy to apply as described by rfc3323.

Enumerator
None | Privacy services must not perform any privacy function.
User | Request that privacy services provide a user-level privacy function.
Header | Request that privacy services modify headers that cannot be set arbitrarily by the user (Contact/Via).
Session | Request that privacy services provide privacy for session media.
Id | rfc3325 The presence of this privacy type in a Privacy header field indicates that the user would like the Network Asserted Identity to be kept private with respect to SIP entities outside the Trust Domain with which the user authenticated.
Critical | Privacy service must perform the specified services or fail the request.
Default | Special keyword to use privacy as defined either globally or by proxy using ProxyConfig::setPrivacy().

## PublishState

enum class linphone::PublishState

strong

Enum for publish states.

Enumerator
None | Initial state, do not use.
IncomingReceived | An incoming publish is received.
Ok | Publish is accepted.
Error | Publish encoutered an error, Event::getReason() gives reason code.
Expiring | Publish is about to expire, only sent if [sip]->refresh_generic_publish property is set to 0.
Cleared | Event has been un published.
Terminating | Publish is about to terminate.
OutgoingProgress | An outgoing publish was created and submitted.

## Reason

enum class linphone::Reason

strong

Enum describing various failure reasons or contextual information for some events.

Enumerator
None | No reason has been set by the core.
NoResponse | No response received from remote.
Forbidden | Authentication failed due to bad credentials or resource forbidden.
Declined | The call has been declined.
NotFound | Destination of the call was not found.
NotAnswered | The call was not answered in time (request timeout).
Busy | Phone line was busy.
UnsupportedContent | Unsupported content.
BadEvent | Bad event.
IOError | Transport error: connection failures, disconnections etc...
DoNotDisturb | Do not disturb reason.
Unauthorized | Operation is unauthorized because missing credential.
NotAcceptable | Operation is rejected due to incompatible or unsupported media parameters.
NoMatch | Operation could not be executed by server or remote client because it didn't have any context for it.
MovedPermanently | Resource moved permanently.
Gone | Resource no longer exists.
TemporarilyUnavailable | Temporarily unavailable.
AddressIncomplete | Address incomplete.
NotImplemented | Not implemented.
BadGateway | Bad gateway.
SessionIntervalTooSmall | The received request contains a Session-Expires header field with a duration below the minimum timer.
ServerTimeout | Server timeout.
Unknown | Unknown reason.
Transferred | The call has been transferred.
ConditionalRequestFailed | Conditional Request Failed.

## RegistrationState

enum class linphone::RegistrationState

strong

Describes proxy registration states.

Enumerator
None | Initial state for registrations.
Progress | Registration is in progress.
Ok | Registration is successful.
Cleared | Unregistration succeeded.
Failed | Registration failed.
Refreshing | Registration refreshing.

## SubscribePolicy

enum class linphone::SubscribePolicy

strong

Enum controlling behavior for incoming subscription request.

Enumerator
SPWait | Does not automatically accept an incoming subscription request.
SPDeny | Rejects incoming subscription request.
SPAccept | Automatically accepts a subscription request.

## SubscriptionDir

enum class linphone::SubscriptionDir

strong

Enum for subscription direction (incoming or outgoing).

Enumerator
Incoming | Incoming subscription.
Outgoing | Outgoing subscription.
InvalidDir | Invalid subscription direction.

## SubscriptionState

enum class linphone::SubscriptionState

strong

Enum for subscription states.

Enumerator
None | Initial state, should not be used.
OutgoingProgress | An outgoing subcription was sent.
IncomingReceived | An incoming subcription is received.
Pending | Subscription is pending, waiting for user approval.
Active | Subscription is accepted.
Terminated | Subscription is terminated normally.
Error | Subscription was terminated by an error, indicated by Event::getReason().
Expiring | Subscription is about to expire, only sent if [sip]->refresh_generic_subscribe property is set to 0.

## SupportLevel

enum class linphone::SupportLevel

strong

Enumerator
NoSupport | No support for the feature.
Optional | Optional support for the feature.
Mandatory | Mandatory support for the feature.

## ToneID

enum class linphone::ToneID

strong

Enum listing frequent telephony tones.

Enumerator
Undefined | Not a tone.
Busy | Busy tone.
CallWaiting | Call waiting tone.
CallOnHold | Call on hold tone.
CallLost | Tone played when call is abruptly disconnected (media lost).
CallEnd | When the call end for any reason but lost.
CallNotAnswered | When the call is not answered.

## UpnpState

enum class linphone::UpnpState

strong

Enum describing uPnP states.

Enumerator
Idle | uPnP is not activate
Pending | uPnP process is in progress
Adding | Internal use: Only used by port binding.
Removing | Internal use: Only used by port binding.
NotAvailable | uPnP is not available
Ok | uPnP is enabled
Ko | uPnP processing has failed
Blacklisted | IGD router is blacklisted.

## VideoSourceType

enum class linphone::VideoSourceType

strong

Enum representing the type of a video source.

Enumerator
Call | The video source is another call.
Camera | The video source is a camera.
Image | The video source is an image.

## ZrtpPeerStatus

enum class linphone::ZrtpPeerStatus

strong

Enum describing the ZRTP SAS validation status of a peer URI.

Enumerator
Unknown | Peer URI unkown or never validated/invalidated the SAS.
Invalid | Peer URI SAS rejected in database.
Valid | Peer URI SAS validated in database.